using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace AssociationOneToOne
{
    class Pracownik : XPObject
    {
        public Pracownik() { }
        public Pracownik(Session Session) : base(Session) { }

        private string imie;
        private string nazwisko;

        public string Imie
        {
            get { return imie; }
            set { imie = value; }
        }
        public string Nazwisko
        {
            get { return nazwisko; }
            set { nazwisko = value; }
        }
        [Association("PracownikNauczyciel")]
        public Nauczyciel Nauczyciel;
    }
    class Nauczyciel : XPObject
    {
        public Nauczyciel() { }
        public Nauczyciel(Session Session) : base(Session) { }

        private int pensja;

        public int Pensja
        {
            get { return pensja; }
            set { pensja = value; }
        }
        [Association("PracownikNauczyciel")]
        public Pracownik Pracownik;

    }
    class Program
    {
        static void Main(string[] args)
        {
            Session session = new Session();
            session.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            session.ClearDatabase();

            Nauczyciel n = new Nauczyciel(session);
            n.Pensja = 2000;
            Pracownik p = new Pracownik(session);
            p.Imie = "Jan";
            p.Nazwisko = "Kowalski";
            n.Pracownik = p;
            p.Nauczyciel = n;
            p.Save(); // lub n.Save()
        }
    }
}
