/*
 * 
 * Prosty przykad implementacji dziedziczenia, w tym w jednej hierarchi zastosowane s obie strategie
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace InheritanceExample1
{
    class Person : XPObject
    {
        public Person() { }
        public Person(Session Session) : base(Session) { }
        
        private string firstName;
        private string lastName;

        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }
        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
    }
    class Employee : Person
    {
        public Employee() { }
        public Employee(Session Session) : base(Session) { }

        private int salary;

        public int Salary
        {
            get { return salary; }
            set { salary = value; }
        }
    }
    [MapInheritance(MapInheritanceType.ParentTable)]
    class Executive : Employee
    {
        public Executive() { }
        public Executive(Session Session) : base(Session) { }

        private int bonus;

        public int Bonus
        {
            get { return bonus; }
            set { bonus = value; }
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Session session = new Session();
            session.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            session.ClearDatabase();

            Executive e = new Executive(session);
            e.FirstName = "John";
            e.LastName = "Kowalski";
            e.Salary = 2000;
            e.Bonus = 4000;
            e.Save();
        }
    }
}
