using System;
using System.Collections.Generic;
using System.Text;

using DevExpress.Xpo;
using DevExpress.Xpo.DB;
using System.Configuration;

namespace PagingExample
{
    class Letter : XPObject
    {
        public string Name;

        public Letter() { }
        public Letter( Session Session ) : base( Session ) { }
        public Letter( Session Session, string Name ) : base( Session ) { this.Name = Name; }
    }
    class Program
    {
        static void Main( string[] args )
        {
            Session session = new Session();
            session.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            session.ClearDatabase();

            new Letter( session, "A" ).Save();
            new Letter( session, "B" ).Save();
            new Letter( session, "C" ).Save();
            new Letter( session, "D" ).Save();
            new Letter( session, "E" ).Save();
            new Letter( session, "F" ).Save();
            new Letter( session, "G" ).Save();
            new Letter( session, "H" ).Save();
            new Letter( session, "I" ).Save();
            new Letter( session, "J" ).Save();
            new Letter( session, "K" ).Save();
            new Letter( session, "L" ).Save();
            new Letter( session, "M" ).Save();
            new Letter( session, "N" ).Save();
            new Letter( session, "O" ).Save();
            new Letter( session, "P" ).Save();
            new Letter( session, "Q" ).Save();
            new Letter( session, "R" ).Save();
            new Letter( session, "S" ).Save();
            new Letter( session, "T" ).Save();
            new Letter( session, "U" ).Save();
            new Letter( session, "V" ).Save();
            new Letter( session, "W" ).Save();
            new Letter( session, "X" ).Save();
            new Letter( session, "Y" ).Save();
            new Letter( session, "Z" ).Save();

            Session session2 = new Session();
            session2.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

            XPCollection<Letter> letters = new XPCollection<Letter>( session2 );
            XPPageSelector pager = new XPPageSelector( letters );
            pager.PageSize = 5;
            pager.CurrentPage = 3;
            Console.WriteLine( "Total pages: {0}", pager.PageCount );
            Console.WriteLine( "Page {0}:", pager.CurrentPage );
            foreach ( Letter l in letters )
            {
                Console.WriteLine( "    {0}", l.Name );
            }

            Console.ReadLine();
        }
    }
}
